package jpatp.sequence;

import java.util.List;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityTransaction;

public class TestMain {
    private EntityManagerFactory factory;
    private EntityManager manager;

    public TestMain() {

        // get EntityManager
        factory = Persistence.createEntityManagerFactory("em1");
        manager = factory.createEntityManager();

        // get transcation
        EntityTransaction transaction = manager.getTransaction();

        try{
            // transaction starts
            transaction.begin();

            for(int a=0; a<10; a++){
              GenerateEntity GEM = new GenerateEntity();
              GEM.setName("KAZUNORI" + a);
              manager.persist(GEM);
//                manager.merge(GEM);
            }

            // commit transaction
            transaction.commit();

            transaction.begin();

            Query query = manager.createNamedQuery("checkQuery");
            List<GenerateEntity> results = PersonEntities.<GenerateEntity> getList(query.getResultList());

            for(GenerateEntity entity : results) {
                System.out.println("### [" + entity.getId() + "] NAME : " + entity.getName()); 
            }

            transaction.commit();

        }
        catch(Throwable th){
            System.err.println("### Unexpected exception occured.");
            System.err.println("### " + th.getMessage());
            th.printStackTrace();
            if (transaction != null && transaction.isActive()){
                transaction.rollback();
            }
        }
        finally{
            // close EntityManager
            if (manager != null && manager.isOpen()){
                manager.close();
            }
            // close EntityManagerFactory
            if (factory != null && factory.isOpen()){
                factory.close();
            }
        }
    }

    public static void main(String[] args) {
        @SuppressWarnings("unused") TestMain testMain = new TestMain();
    }
}
